﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace NavAddin
{

	public class MouseCursorDef
	{
		public BitmapImage CursorImage { get; set; }
		public Point HotSpot { get; set; }
	}

	public partial class ucMouseCursor : UserControl
	{

		private Dictionary<string, MouseCursorDef> _Cursors;
		private Point _hotspot;

		public ucMouseCursor()
		{
			InitializeComponent();
			_Cursors = new Dictionary<string, MouseCursorDef>();
		}

		public void RegisterCursor(string MyKey, MouseCursorDef MyCursorDef = null)
		{
			_Cursors[MyKey] = MyCursorDef;
		}

		public void SetCursor(string MyKey)
		{
			if (MyKey == "")
			{
				this.Visibility = Visibility.Collapsed;
				return;
			}
			MouseCursorDef MyCursorDef = _Cursors[MyKey];
			if (MyCursorDef == null)
			{
				this.Visibility = Visibility.Collapsed;
				return;
			}
			MyCursor.Source = MyCursorDef.CursorImage;
			_hotspot = MyCursorDef.HotSpot;
			MyCursor.Stretch = Stretch.None;
			MyCursor.Cursor = Cursors.None;
			MyCursor.IsHitTestVisible = false;
			MyCanvas.Cursor = Cursors.None;
			MyCanvas.IsHitTestVisible = false;
			this.Visibility = Visibility.Visible;
		}

		public void MoveTo(Point pt) 
		{ 
			MyCursor.SetValue(Canvas.LeftProperty, pt.X - _hotspot.X); 
			MyCursor.SetValue(Canvas.TopProperty, pt.Y - _hotspot.Y); 
		}

	}
}
